﻿<?php



/**
 * Retrieve category parents with Rich-Snippets Breadcrumb
 */
function get_my_category_parents( $id, $link = false, $separator = '/', $nicename = false, $visited = array() ) {
	$chain = '';
	$parent = &get_category( $id );
	if ( is_wp_error( $parent ) )
		return $parent;

	if ( $nicename )
		$name = $parent->slug;
	else
		$name = $parent->name;

	if ( $parent->parent && ( $parent->parent != $parent->term_id ) && !in_array( $parent->parent, $visited ) ) {
		$visited[] = $parent->parent;
		$chain .= get_category_parents( $parent->parent, $link, $separator, $nicename, $visited );
	}

	if ( $link )
		$chain .= '<div class="item" itemscope itemtype="http://data-vocabulary.org/Breadcrumb"><a itemprop="url" href="' . get_category_link( $parent->term_id ) . '" title="' . esc_attr( sprintf( __( "View all posts in %s" ), $parent->name ) ) . '"><span itemprop="title">'.$name.'</span></a></div>' . $separator;
	else
		$chain .= '<div class="item" itemscope itemtype="http://data-vocabulary.org/Breadcrumb"><span itemprop="title">'.$name.'</span></div>' .$separator;
	return $chain;
}



function write_breadcrumb() {
    $pid = $post->ID;
 $trail = '
 <div id="breadcrumb">
 	<div class="item" itemscope itemtype="http://data-vocabulary.org/Breadcrumb"><a itemprop="url" href="/"><span itemprop="title">Home</span></a></div>';
 
    if (is_front_page()) {
        // do nothing
	}
		elseif (is_page()) {
			$bcarray = array();
			$pdata = get_post($pid);
			$bcarray[] = ' &raquo; <div class="item" itemscope itemtype="http://data-vocabulary.org/Breadcrumb"><span itemprop="title">'.$pdata->post_title.'</span></div>'."\n";
			while ($pdata->post_parent) {
				$pdata = get_post($pdata->post_parent);
				$bcarray[] = ' &raquo; <div class="item" itemscope itemtype="http://data-vocabulary.org/Breadcrumb"> <a itemprop="url"  href="'.get_permalink($pdata->ID).'"><span itemprop="title">'.$pdata->post_title.'</span></a></div>';
			}
		   $bcarray = array_reverse($bcarray);
			 foreach ($bcarray AS $listitem) {
				 $trail .= $listitem;
			 }
		}
		elseif (is_single()) {
			$pdata = get_the_category($pid);
			$adata = get_post($pid);
			if(!empty($pdata)){
				$data = get_my_category_parents($pdata[0]->cat_ID, TRUE, ' &raquo; ');
				$trail .= " &raquo; ".substr($data,0,-8);
			}
			$trail.= ' &raquo; <div class="item" itemscope itemtype="http://data-vocabulary.org/Breadcrumb"><span itemprop="title">'.$adata->post_title.'</span></div>'."\n";
		}
	   	elseif (is_category()) {
			$pdata = get_the_category($pid);
			$data = get_my_category_parents($pdata[0]->cat_ID, TRUE, ' &raquo; ');
			if(!empty($pdata)){
				$trail .= " &raquo; ".substr($data,0,-8);
			}
	   	}
 $trail.="</div>";
 return $trail;
}


?>